%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Attention, ce script utilise les fonctions
% * diff_div_dist, eval_horner distribues avec le corrig de TP
% * simpsonc distribue avec les sujets de TP.
% ger=0 pour faire sujet, corrigs avec matex
% ger=1 pour script de correction
ger=1;

% donnes
h=0.5;
x=1:h:4;
% troncature propose pour simplifier
x=x(1:5);
a=min(x);
b=max(x);
xg=linspace(min(x)-h/2,max(x)+h/2,1000);
y=[4.4755   5.3996    6.5496    7.8216    9.1997   10.6096   12.0049];
% troncature propose pour simplifier
y=y(1:5);
% calculs
z=spline(x,y);
t0=1.2;
I1=1:3;
I2=1:4;
D=diff_div_dist(x(I2),y(I2));
val1=eval_horner(t0,x(I1(1:end-1)),D(1:end-1));
val2=eval_horner(t0,x(I2(1:end-1)),D);
m=length(x)-1;
f=@(x) ppval(z,x);
% calcul par trapze
Itra=h*trapz(y);
% trapze variante
Itra(2)=trapezc(a,b,m,f);
% calcul par rectangle
% NON UTILISE POUR L'nonc
Irect=h*sum(y(1:end-1));
% rectangle variante
Irect(2)=rectanglec(a,b,m,f);
% calcul par point mileu
% en utilisant les valeurs des splines au milieu
% (mthode incite par l'nonc)
mi=(x(1:end-1)+x(2:end))/2;
ymi=ppval(z,mi);
Imil=h*sum(ymi);
% milieu variante
Imil(2)=point_milieuc(a,b,m,f);
% calcul par Simpson
% en utilisant les valeurs des splines au milieu
% (mthode incite par l'nonc)
mi=(x(1:end-1)+x(2:end))/2;
ymi=ppval(z,mi);
Isimp=(h/6)*(y(1)+y(end)+2*sum(y(2:end-1))+4*sum(ymi));
% Simpson variante
Isimp(2)=simpsonc(a,b,m,f);
% autre faon de faire en prenant un pas h du double du pas et un point
% sur deux et sans utiliser les  milieux
% marche car nombre de points impair !
% Milieu
sx=length(x);
if mod(sx,2)==0
    error('Nombre de points pair');
end
malt=(sx-1)/2;
halt=2*h;
Imilalt=halt*sum(y(2:2:end-1));
% milieu variante
Imilalt(2)=point_milieuc(a,b,malt,f);
% Simpson
Isimpalt=(halt/6)*(y(1)+y(end)+2*sum(y(3:2:end-1))+4*sum(y(2:2:end-1)));
% Simpson variante
Isimpalt(2)=simpsonc(a,b,malt,f);
% calcul de l'intgrale exacte.
Iexa=0;
for i=1:z.pieces
   Q=z.coefs(i,:);
   Q=polyint(Q);
   Iexa=Iexa+polyval(Q,z.breaks(i+1)-z.breaks(i));
end
% trois calculs simultans et plus rapides des intgrales approches
% pour rectangles, trapze, milieux et  Simpson
S=h*sum(y(2:end-1));
Sp=h*sum(ymi);
Irect(3)=h*y(1)+S;
Imil(3)=Sp;
Itra(3)=h/2*(y(1)+y(end))+S;
Isimp(3)=1/6*(h*(y(1)+y(end))+2*S+4*Sp);


%% question 1) 
if ger==1
    disp('Question 1');
    disp('Diffrences divises pour polynme de degr 2');
    disp(D(1:end-1));
    disp('en t0');
    disp(val1);
    disp('Diffrence divise supplmentaire pour polynme de degr 3');
    disp(D(end));
    disp('en t0');
    disp(val2);
end
close all;
figure;
plot(x,y,'*',xg,eval_horner(xg,x(I1(1:end-1)),D(1:end-1)),'-.',xg,eval_horner(xg,x(I2(1:end-1)),D),t0,val1,'o',t0,val2,'s');
legend('points','parabolique','cubique',0);
if ger==1
    pause;
end

%% question 2a) 
if ger==1
    disp('Question 2a');
    disp('Intgrale rectangle (non demande dans l''exercice)');
    disp(Irect);
    disp('Intgrale trapze');
    disp(Itra);
    pause;
end

%% question 2b) 
if ger==1
    disp('Question 2b');
    disp('Intgrale milieu en prenant les milieux');
    disp(Imil);
    disp('Intgrale Simpson en prenant les milieux');
    disp(Isimp);
    pause;
    disp('Intgrale milieu en ne prenant pas les milieux');
    disp(Imilalt);
    disp('Intgrale Simpson en ne prenant pas les milieux');
    disp(Isimpalt);
    pause;
end


%% Complments
if ger==1
    disp('Complments');
end
% calculs sur la spline et de l'intgrale exacte.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ATTENTION, l'aide de mkpp (en commande et pas en html !!) dit 
%    "BREAKS must be a vector of length L+1 with
%     strictly increasing elements representing the start and end of each of L
%     intervals.  The matrix COEFS must be L-by-K, with the i-th row, 
%     COEFS(i,:), representing the local coefficients of the order K polynomial
%     on the interval [BREAKS(i) ... BREAKS(i+1)], i.e., the polynomial                 
%     COEFS(i,1)*(X-BREAKS(i))^(K-1) + COEFS(i,2)*(X-BREAKS(i))^(K-2) + ... 
%     COEFS(i,K-1)*(X-BREAKS(i)) + COEFS(i,K)"
% vrification par plusieurs mthodes que la spline vaut 
% bien y_i en x_i
% le er affich doit tre nul !
er=0;
for i=1:z.pieces
    er=max(abs([er,y(i:i+1)-ppval(z,z.breaks(i:i+1)),y(i:i+1)-polyval(z.coefs(i,:),z.breaks(i:i+1)-z.breaks(i))]));
end
if ger==1
    disp('vrification que la spline vaut y_i en t_i');
    disp(er);
    disp('Intgrale exacte');
    disp(Iexa);
    disp('carts entre intgrale exacte et Simpson');
    disp(abs(Iexa-Isimp));
end
% graphique
figure;
plot(x,y,'*',xg,ppval(z,xg));
legend('points','spline',0);

%% remarque
if ger==1
    disp('remarque');
    disp('On peut simplifier le calcul des trois approximations des intgrales ...');
    disp('Voir rsultats affichs plus haut');
end

%% Impressions finales des figures.
if ~ger
    print -f1 -depsc dessins/figexamcorMNBA13.eps;
    print -f2 -depsc dessins/figexamMNBA13.eps;
    close all;
end